Imports CPMotor_DotNET

Public Class Form1

    Const Max_Motor = 3
    Const Motor_Step = 100

    Dim Slot As Byte = 0
    Dim Baud As Byte = 5
    Dim Type As Byte = 1
    Dim Id(Max_Motor) As Byte

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        combo_slot.SelectedIndex = 0
        combo_baud.SelectedIndex = 5
        combo_motortype.SelectedIndex = 1
        combo_motorid1.SelectedIndex = 0
        combo_motorid2.SelectedIndex = 1
        combo_motorid3.SelectedIndex = 2

        Slot = 0
        Baud = 5
        Type = 1

        Id(0) = 1
        Id(1) = 2
        Id(2) = 3
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Dim ret As UInt16, i As UInt16

        For i = 0 To Max_Motor - 1
            ret = CPMotor.CPMotor_MotionStop(Slot, Id(i), 300)
            If (ret <> 0) Then
                MessageBox.Show("CPMotor_MotionStop " + (i + 1).ToString() + " Error " + ret.ToString())
            Else
                ret = CPMotor.CPMotor_CloseMotor(Slot, Id(i))
                If (ret <> 0) Then
                    MessageBox.Show("CPMotor_CloseMotor " + (i + 1).ToString() + " Error " + ret.ToString())
                End If
            End If

            ret = CPMotor.CPMotor_ShutdownMaster(Slot)
            If (ret <> 0) Then
                MessageBox.Show("CPMotor_ShutdownMaster Error " + ret.ToString())
            End If
        Next i
    End Sub

    Private Sub combo_slot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_slot.SelectedIndexChanged
        Slot = combo_slot.SelectedIndex
    End Sub

    Private Sub combo_baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_baud.SelectedIndexChanged
        Baud = combo_baud.SelectedIndex
    End Sub

    Private Sub combo_motortype_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_motortype.SelectedIndexChanged
        Type = combo_motortype.SelectedIndex
    End Sub

    Private Sub combo_motorid1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_motorid1.SelectedIndexChanged
        Id(0) = (combo_motorid1.SelectedIndex + 1)
    End Sub

    Private Sub combo_motorid2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_motorid2.SelectedIndexChanged
        Id(1) = (combo_motorid2.SelectedIndex + 1)
    End Sub

    Private Sub combo_motorid3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles combo_motorid3.SelectedIndexChanged
        Id(2) = (combo_motorid3.SelectedIndex + 1)
    End Sub

    Private Sub btn_initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_initial.Click
        Dim ret As UInt16, i As UInt16
        Dim err_cnt As Byte = 0
        Dim cur_position(Max_Motor) As Int32

        ' Initial I-8123W and Motor Device
        ret = CPMotor.CPMotor_InitMaster(CPMotor.MASTERMODULE.MASTER_MODULE_I8123W, Slot, Baud)
        If (ret <> 0) Then
            MessageBox.Show("CPMotor_InitMaster Error " + ret.ToString())
        Else
            For i = 0 To Max_Motor - 1
                ret = CPMotor.CPMotor_AddMotor(Slot, Id(i), 1, 200, Type)
                If (ret <> 0) Then
                    MessageBox.Show("CPMotor_AddMotor " + (i + 1).ToString() + " Error " + ret.ToString())
                    err_cnt += 1
                Else
                    ret = CPMotor.CPMotor_InitMotor(Slot, Id(i), 100)
                    If (ret <> 0) Then
                        MessageBox.Show("CPMotor_InitMotor " + (i + 1).ToString() + " Error " + ret.ToString())
                        err_cnt += 1
                    Else
                        ' Call CPMotor_IPInitial to into Interpolation mode
                        ret = CPMotor.CPMotor_IPInitial(Slot, Id(i))
                        If (ret <> 0) Then
                            MessageBox.Show("CPMotor_IPInitial " + (i + 1).ToString() + " Error " + ret.ToString())
                            err_cnt += 1
                        End If
                    End If
                End If
            Next i

            If (err_cnt <> 0) Then Return

            MessageBox.Show("AddMotor and InitMotor OK")

            btn_initial.Enabled = False

            combo_slot.Enabled = False
            combo_baud.Enabled = False
            combo_motortype.Enabled = False
            combo_motorid1.Enabled = False
            combo_motorid2.Enabled = False
            combo_motorid3.Enabled = False

            bar_wpos1.Enabled = True
            bar_wpos2.Enabled = True
            bar_wpos3.Enabled = True

            System.Threading.Thread.Sleep(100)

            timer1.Enabled = True
        End If
    End Sub
    Private Sub btn_move_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_move.Click
        Dim ret As UInt16, i As UInt16, j As UInt16
        Dim abs(Max_Motor) As Byte
        Dim path(Max_Motor * Motor_Step) As Int32

        ' Select Relative Path
        abs(0) = 0
        abs(1) = 0
        abs(2) = 0

        ' Motor 0: Move 10 Pulse per Step
        ' Motor 1: Move 20 Pulse per Step
        ' Motor 2: Move 30 Pulse per Step
        For j = 0 To Max_Motor - 1
            For i = 0 To Motor_Step - 1
                path((j * Motor_Step) + i) = 10 * (j + 1)
            Next i
        Next j

        ' Interpolation Move Start
        ret = CPMotor.CPMotor_IP_PathMove(Slot, Max_Motor, Id, abs, Motor_Step, path, 1)
        If (ret <> 0) Then
            MessageBox.Show("CPMotor_IP_PathMove Error " + ret.ToString())
            Return
        End If
    End Sub

    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim ret As UInt16, i As UInt16
        Dim currmode As Byte = 0
        Dim isservoready As Byte = 0
        Dim isfault As Byte = 0
        Dim iswarning As Byte = 0
        Dim isdone As Byte = 0
        Dim statusword As UInt16 = 0
        Dim cur_position(Max_Motor) As Int32

        For i = 0 To Max_Motor - 1
            ' Check Motor Status
            ret = CPMotor.CPMotor_MotorStatus(Slot, Id(i), currmode, isservoready, isfault, iswarning, isdone, statusword)
            If (ret = 0) Then
                If (i = 0) Then
                    If (isfault <> 0) Then
                        lab_status1.Text = "Motor 1 Fault"
                    ElseIf (iswarning <> 0) Then
                        lab_status1.Text = "Motor 1 Warning"
                    ElseIf (isdone <> 0) Then
                        lab_status1.Text = "Motor 1 Done"
                    End If
                End If

                If (i = 1) Then
                    If (isfault <> 0) Then
                        lab_status2.Text = "Motor 2 Fault"
                    ElseIf (iswarning <> 0) Then
                        lab_status2.Text = "Motor 2 Warning"
                    ElseIf (isdone <> 0) Then
                        lab_status2.Text = "Motor 2 Done"
                    End If
                End If

                If (i = 2) Then
                    If (isfault <> 0) Then
                        lab_status3.Text = "Motor 3 Fault"
                    ElseIf (iswarning <> 0) Then
                        lab_status3.Text = "Motor 3 Warning"
                    ElseIf (isdone <> 0) Then
                        lab_status3.Text = "Motor 3 Done"
                    End If
                End If
            End If
        Next i

        '////////// Get Current Position and Set to Silder /////////////
        For i = 0 To Max_Motor - 1
            ret = CPMotor.CPMotor_PP_CurrentPosition(Slot, Id(i), cur_position(i))
            If (ret = 0) Then
                If (i = 0) Then
                    bar_wpos1.Value = (cur_position(0) / 65536)
                    text_wpos1.Text = cur_position(0).ToString()
                End If
                If (i = 1) Then
                    bar_wpos2.Value = (cur_position(1) / 65536)
                    text_wpos2.Text = cur_position(1).ToString()
                End If
                If (i = 2) Then
                    bar_wpos3.Value = (cur_position(2) / 65536)
                    text_wpos3.Text = cur_position(2).ToString()
                End If
            End If
        Next i
    End Sub
End Class
